﻿init python:
    from copy import copy
    import random
    import time
    random.seed(time.clock())

    class cars_car_class:
        def __init__(self, image, speed):
            self.image = image
            self.speed = speed
            self.x = 0
            self.y = -300
            self.active = True
    class cars_class:
        def __init__(self, my_car, cars):
            self.speed = .1
            self.lanes = 3
            self.lane_offset = 0
            self.cars = cars
            self.active_cars = []
            self.my_car = my_car
            self. x = 0
            self. y = 96
        def change_lane(self, direction):
            if direction == "left":
                self.x -= 1
            elif direction == "right":
                self.x += 1
        def tick(self):
            self.lane_offset += 2
            if self.lane_offset > 32:
                self.lane_offset = 0
            for i in self.active_cars:
                i.y += 1
                if i.y > 150:
                    i.active = False
        def spawn(self):
            if self.speed > 0.01:
                self.speed -= 0.01
            car = copy(random.choice(self.cars))
            car.x = random.randint(-1,1)
            for i in self.active_cars:
                if i.active == False:
                    i.image = car.image
                    i.speed = car.speed
                    i.y = -150
                    i.x = car.x
                    i.active = True
                    break
            else:
                if len(self.active_cars) < 5:
                    self.active_cars.append(car)


image cars_1 = Crop((0, 0,16, 32), "cars/cars.png")
image cars_2 = Crop((16, 0,16, 32), "cars/cars.png")
image cars_3 = Crop((32, 0,16, 32), "cars/cars.png")
image cars_4 = Crop((48, 0,16, 32), "cars/cars.png")
image cars_5 = Crop((64, 0,16, 32), "cars/cars.png")

image cars_6 = Crop((0, 32,18, 32), "cars/cars.png")
image cars_7 = Crop((20, 32,20, 32), "cars/cars.png")
image cars_8 = Crop((40, 32,20, 36), "cars/cars.png")
image cars_9 = Crop((62, 32,18, 32), "cars/cars.png")

default cars_lemon = cars_car_class("cars_1", 6)
default cars_taxi = cars_car_class("cars_2", 10)
default cars_red = cars_car_class("cars_3", 14)
default cars_silver = cars_car_class("cars_4", 16)
default cars_mini = cars_car_class("cars_5", 5)
default cars_convert = cars_car_class("cars_6", 14)
default cars_police = cars_car_class("cars_7", 14)
default cars_van = cars_car_class("cars_8", 12)
default cars_yellow = cars_car_class("cars_9", 18)

default cars_instance = cars_class(
    "cars_1",
    [
        cars_lemon,
        cars_taxi,
        cars_red,
        cars_silver,
        cars_mini,
        cars_convert,
        cars_police,
        cars_van,
        cars_yellow,
    ]
)



transform cars_other_cars(lane, y):
    xoffset (lane*32) yoffset y
transform cars_lane_changer(lane, y):
    ease .1 xoffset (lane*32) yoffset y
transform zoom(z):
    nearest True
    zoom z

screen cars_screen(g = cars_instance):
    modal True
    key "a" action Function(g.change_lane, "left")
    key "d" action Function(g.change_lane, "right")

    timer 2 repeat True action Function(g.spawn)
    timer g.speed repeat True action Function(g.tick)
    fixed xysize 480,270:
        at zoom(4)
        add "#4ec114"
        hbox align .5,1.0:
            yoffset g.lane_offset
            add "cars/left.png"
            for i in range(g.lanes):
                add "cars/lane.png"
            add "cars/right.png"
        add g.my_car at cars_lane_changer(g.x, g.y) align .5,.5
        for i in g.active_cars:
            if i.active:
                add i.image at cars_other_cars(i.x, i.y) align .5,.5
        # hbox spacing 20:
        #     for i in range(1,10):
        #         add "cars_{}".format(i)


label cars_example:
    call screen cars_screen
